{***************************************
 *  Serial RFID test                    *
 *  Author: Kurt Winn March 2015       *
 *  Copyright (c) 2015 Kurt Winn       *
 *  See end of file for terms of use.  *
 ***************************************

}

CON
        _clkmode = xtal1 + pll16x                       'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        clk_freq = (_clkmode >> 6) * _xinfreq           ' system freq as a constant
        ms001   = clk_freq / 1_000                      ' ticks in 1ms
        us001   = clk_freq / 1_000_000                  ' ticks in 1us

'********************************************************************************************************
' FDSQ Serial port definitions 
'********************************************************************************************************
  rx0 = 31  ' debug port for pst
  tx0 = 30
  
  rx1 = 0  ' rfid port
  tx1 = 1  
  
'********************************************************************************************************
' Card reader interface definitions 
'********************************************************************************************************
  enable = 2                   ' /Enable signal for reader
  rdrdel = 100                 ' Time delay for card reader
  
VAR

  word  current              
   
OBJ
  ser   :       "FDSQ-64"       ' Full duplex four port object

  io    :       "i_o"           ' .high(pin) .low(pin) .toggle(pin) .input(pin) .pulse(pin) .freq_out(ctrx, pinx, freqx)
  
  time  :       "timer"         ' .start .startx(now) .set(ms) .millis .seconds .adjust(offset) .mark .get_sync .pause(ms) .pause_us(us)

pub start  | char                            
'********************************************************************************************************
' Enable the reader and send card data to the terminal/PST  
'********************************************************************************************************
  io.high(enable)               ' disable the reader
  serinit                       ' initialize the serial driver
  time.start                    ' start the timer
  time.pause(10000)
  ser.str(0, string("RFID Test")) 
  ser.tx(0,13)
  ser.tx(0,13)

  repeat
    io.low(enable)                                      ' enable card reader
    repeat until ser.rx(1) == 10
    ser.str(0, string(" - Tag ID = ")) 
    repeat until char == 13
      char := ser.rxtime(1,100)
      ser.tx(0,char)
    ser.tx(0,13)
    char := 0                                           ' reset character to null
    io.high(enable)
    time.pause(1500)
           
pri serinit
'********************************************************************************************************
' Full Duplex serial four port initialization
' AddPort(port,rxpin,txpin,ctspin,rtspin,rtsthreshold,mode,baudrate)
'********************************************************************************************************
  ser.AddPort(0, rx0, tx0, -1, -1, 0, 0 ,19200) ' initialize port 0 as debug port for PST
  ser.AddPort(1, rx1, tx1, -1, -1, 0, 0 ,2400)  ' initialize port 1 as card reader port
  ser.start                       ' start cog
  
dat


{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}        